# How to Develop and Use Libcaosdb

## Build

We use [cmake](https://cmake.org) as build tool.

1. `cmake -B build`
2. `cd build`
3. `cmake --build .`

## Unit Tests

### Run

Build tests as described above. In the build directory, run `ctest`

### Framework

We use [GoogleTest](https://google.github.io/googletest/) for unit testing.

### Coverage

We use [gcov](https://gcc.gnu.org/onlinedocs/gcc/Gcov.html) and
[lcov](https://github.com/linux-test-project/lcov) for generating test coverage
reports.

In the build directory, generate the coverage report by running
`cmake --build . --target unit_test_coverage`.

Note that this special target will run the tests again. Thus it is not
necessary to run `ctest` prior to this target.

The coverage report can be viewed in a browser by opening
`<build_directory>/unit_test_coverage/index.html`.

## Code Formatting

* `clang-format -i --verbose **/*.c **/*.h`

## Documentation

In the build directory, run

* `cmake --build . --target doc-doxygen` (generate Doxygen)
* `cmake --build . --target doc-sphinx` (generate Sphinx)
